/** @file ccp_scen.h
 *
 * @author Alexander Kamkin (kamkin@ispras.ru)
 */

#pragma once

#include <ts/scenario.hpp>

#include <ccp_model.h>

using namespace cpptesk::ts;
using namespace cpptesk::hw;
using namespace cpptesk::tracer;

namespace cpptesk {
namespace examples {
namespace ccp {

SCENARIO(CacheCoherenceScenario)
{
public:
    typedef IntAbcCtx Ctx;

    static const unsigned N = 8;

    CacheCoherenceScenario(): model(N)
    {
        setup("CacheCoherenceScenario",
            &CacheCoherenceScenario::init,
            &CacheCoherenceScenario::finish,
            &CacheCoherenceScenario::getState);

        SCENARIO_METHOD(CacheCoherenceScenario::read);
        SCENARIO_METHOD(CacheCoherenceScenario::write);
        SCENARIO_METHOD(CacheCoherenceScenario::replace);
    }

    virtual ~CacheCoherenceScenario() {}

    virtual bool init(int argc, char ** argv);
    virtual void finish();

    bool read   (Ctx &ctx);
    bool write  (Ctx &ctx);
    bool replace(Ctx &ctx);
    bool reset  (Ctx &ctx);

    std::string getState();

protected:
    CacheCoherenceModel model;
};

}}} // namespace cpptesk::examples::ccp

