/** @file counter_media.h
 * This file contains counter model modiator class description.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#pragma once

#include <hw/veritool/media.hpp>
#include <counter_model.h>
#include <interface.h>

#include <string>

namespace cpptesk {
namespace examples {
namespace counter {

VERITOOL_ADAPTER(CounterMediator, Counter)
{
public:
    CounterMediator();
    virtual ~CounterMediator();

    const static int REACTION_TIMEOUT = 5;

    virtual bool isIface1Ready() const;

    DECLARE_PROCESS(serialize_iface1);

    DECLARE_PROCESS(deserialize_iface2);

    DEFINE_BASIC_OUTPUT_LISTENER(listen_iface2, iface2, false);

    DECLARE_ARBITER(PRIORITY_ARBITER, matcher_iface2);
};

}}}
