/*
 * Copyright 2010 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Kamkin (kamkin@ispras.ru)
// SYNOPSIS: Interface of the simulator synchronizer 
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include <hw/defs.hpp>

namespace cpptesk {
namespace hw {

struct Synchronizer
{
    virtual ~Synchronizer() {}
    virtual void initialize() = 0;
    virtual void finalize() = 0;
    virtual void setInputs() = 0;
    virtual void getOutputs() = 0;
    virtual void simulate() = 0;
};

}} // namespace cpptesk::hw

