/*
 * Copyright 2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/* 
 * Aspectrace for C usage example
 */

#include <stdio.h>
#include "aspectrace.h"
#include "aspect_coverage.h"

int main(int argc, char **argv)
{
	aspectrace_addTcpSocket("127.0.0.1", 6543);
	aspectrace_addTcpSocket("127.0.0.1", 12345);
	aspectrace_addTcpSocket("127.0.0.1", 54321);
	aspectrace_addXmlTrace("./CTESK_trace.1.xml");
	aspectrace_addXmlTrace("./CTESK_trace.2.xml");
//	aspectrace_addXmlTrace("./CTESK_trace.3.xml");
//	aspectrace_addXmlTrace("./CTESK_trace.4.xml");

	aspect_coverage_traceCoverageStructure(
		"aspect_<>",
		"int& method()",
		create_CoverageElement("branch 1",
			create_CoverageElement("\"mark\" 1", NULL),
			create_CoverageElement("\"mark\" 2", create_CoverageElement("\"mark\" 21", NULL), create_CoverageElement("\"mark\" 22", NULL), NULL),
			create_CoverageElement("\"mark\" 3", create_CoverageElement("\"mark\" 31", NULL), create_CoverageElement("\"mark\" 32", NULL), NULL),
			NULL
		),
		create_CoverageElement("branch 2", NULL),
		NULL
	);

	aspect_coverage_traceCoverageElement(
		"oracle",
		"int& method()",
		"branch 1", "\"mark\" 2", "\"mark\" 21", NULL);

	aspect_coverage_traceCoverageElement(
		"oracle",
		"int& method()",
		"branch 1", "\"mark\" 3", "\"mark\" 31", NULL);

	aspect_coverage_traceCoverageElement(
		"oracle",
		"int& method()",
		"branch 1", "\"mark\" 3", "\"mark\" 32", NULL);

	aspect_coverage_traceCoverageElement(
		"oracle",
		"int& method()",
		"branch 2", NULL);
	
	aspect_error_traceFailure("oracle", "<Single&> \"line\"", NULL);
	aspect_error_traceFailure("oracle", "<Multi&> \"line\"", "First line\nSecond line\nThird line with <![[CDATA[inside]]>");
	
	aspectrace_finishTracing();

	return 0;
}

