#!/bin/bash

basedir=`dirname "$0"`

if [ -f "$HOME/.bashrc" ]
then
  result="`grep -c "mcc/src/mhttpd/libmicrohttpd/lib" ~/.bashrc`"
else
  result="0"
fi

case $result in
"0" )
  cat $basedir/.bashrc >> "$HOME/.bashrc"
  echo "[OK] .bashrc has been appended with the path to the libmicrohttpd."
;;
* )
  echo "[INFO] .bashrc already includes the information about the path to the libmicrohttpd."
;;
esac

cd $basedir
tar xf lib*.gz
cd libmicrohttpd-*
./configure --prefix="`pwd`/../libmicrohttpd"
make install

